<?php

namespace Quivers\Integration\Block\Sales\Adminhtml\Order;

class View extends \Magento\Sales\Block\Adminhtml\Order\View
{

    /**
     * @param \Magento\Backend\Block\Widget\Context $context
     * @param \Magento\Framework\Registry $registry
     * @param \Magento\Sales\Model\Config $salesConfig
     * @param \Magento\Sales\Helper\Reorder $reorderHelper
     * @param array $data
     */
    public function __construct(
        \Magento\Backend\Block\Widget\Context $context,
        \Magento\Framework\Registry $registry,
        \Magento\Sales\Model\Config $salesConfig,
        \Magento\Sales\Helper\Reorder $reorderHelper,
        array $data = []
    ) {
        parent::__construct($context, $registry, $salesConfig, $reorderHelper, $data);
    }

    /**
     * Constructor
     *
     * @return void
     * @SuppressWarnings(PHPMD.CyclomaticComplexity)
     * @SuppressWarnings(PHPMD.NPathComplexity)
     * @SuppressWarnings(PHPMD.ExcessiveMethodLength)
     */
    protected function _construct()
    {
        parent::_construct();

        $order = $this->getOrder();

        if (!$order) {
            return;
        }

        if ($this->_isAllowedAction('Magento_Sales::unhold') && $order->canUnhold()) {
            $message = __('This order is currently available to retailers, claimed by a retailer, or undergoing fraud review. Are you sure you want to proceed with processing this order?');
            $this->removeButton('order_unhold');
            $this->addButton(
                'order_unhold_quivers',
                [
                    'label' => __('Unhold'),
                    'class' => __('unhold'),
                    'id' => 'order-view-unhold-button-quivers',
                    'on_click' => "confirmSetLocation('{$message}', '{$this->getUnHoldUrl()}')",
                    'data_attribute' => [
                        'url' => $this->getUnHoldUrl(),
                    ]
                ]
            );
        }
    }
}
