<?php
namespace Quivers\Integration\Model;

use Magento\ConfigurableProduct\Model\Product\Type\Configurable;

/**
 * @SuppressWarnings(PHPMD.CouplingBetweenObjects)
 */
class ParentProductManagement implements \Quivers\Integration\Api\ParentProductManagementInterface
{
    /**
     * @var \Magento\ConfigurableProduct\Model\Product\Type\Configurable
     */
    private $configurable;
    /**
     * @var \Magento\Catalog\Api\ProductRepositoryInterface
     */
    private $productRepository;
    /**
     * @var \Magento\Catalog\Api\Data\ProductInterfaceFactory
     */
    private $productFactory;
    public function __construct(
       Configurable $configurable,
       \Magento\Catalog\Api\ProductRepositoryInterface $productRepository,
       \Magento\Catalog\Api\Data\ProductInterfaceFactory $productFactory
    ) {
        $this->configurable = $configurable;
        $this->productRepository = $productRepository;
        $this->productFactory = $productFactory;
    }
    /**
     * {@inheritdoc}
     */
    public function getParentIdsByChild($childId)
    {
        $parentIds = $this->configurable->getParentIdsByChild($childId);
        $parentList = [];
        if (!empty($parentIds)) {
            foreach ($parentIds as $parentId) {
                $parentList[] = $this->productRepository->getById($parentId);
            }
        }
        return $parentList;
    }
    /**
     * {@inheritdoc}
     */
    public function getParentIdsByChildSku($childSku)
    {
        $child = $this->productRepository->get($childSku);
        if ($child->getTypeId() != \Magento\ConfigurableProduct\Model\Product\Type\Configurable::TYPE_CODE) {
            return [];
        }
        return $this->getParentIdsByChild($child->getId());
    }
}