<?php

namespace Quivers\Integration\Observer;

use Magento\Framework\Event\ObserverInterface;
use Magento\Framework\Event\Observer as EventObserver;

class ProductSaveAfterObserver implements ObserverInterface
{   protected $scopeConfig;
	const XML_QUIVERS_UPC = 'quivers/parameters/quivers_custom_upc';
    public function execute(EventObserver $observer)
    {
		
		$scopeConfig = \Magento\Framework\App\ObjectManager::getInstance()->get(\Magento\Framework\App\Config\ScopeConfigInterface::class);
		$storeScope = \Magento\Store\Model\ScopeInterface::SCOPE_STORE;
        $quivers_upc = $scopeConfig->getValue(self::XML_QUIVERS_UPC, $storeScope);
        $product = $observer->getProduct();  // you will get product object
		$taxCode = $product->getData('product_tax_category');
		$product->setData('backend_upc',"quivers_custom_upc_".$quivers_upc);
		$product->getResource()->saveAttribute($product,'backend_upc');
    	if ($product->getData('type_id') == 'configurable'){
    	$productTypeInstance = $product->getTypeInstance();
    	$usedProducts = $productTypeInstance->getUsedProducts($product);

    	foreach ($usedProducts  as $child) {
    		if ($product->getData('type_id') != 'virtual')
    		{
        	$child->setData('product_tax_category', $taxCode);
			$child->getResource()->saveAttribute($child, 'product_tax_category');
        	}
    		
    		}
    	}

    }   
}